﻿-- Author      : Brandon
-- Create Date : 10/19/2008 12:05:01 PM
local L = LibStub('AceLocale-3.0'):GetLocale('SRT', true)
--local LSM = LibStub('LibSharedMedia-3.0')
local AceConfigDialog = LibStub('AceConfigDialog-3.0')
local AceConfig = LibStub('AceConfig-3.0')
local AceDBOptions = LibStub('AceDBOptions-3.0')

local deleteIgnoredItems = {}

local SRTAddedToBlizzConfig = false
function SRT:CreateConfigMenu()	
	local options = {
		name = L['Seraphim Raid Tracker'],
		handler = SRT,
		desc = L['ModDesc'],
		childGroups = 'tab',
		type = 'group',
		args = {
			Show = {
				type = 'execute',
				name = 'show',
				desc = L['Show Desc'],
				func =	function()
							AceConfigDialog:Open('SRTConfig')	
						end,
				guiHidden = true,
			},
			--CurrentStats = {
			--	type = 'group',
			--	name = L['Current Stats'],
			--	order = 5,
			--	args = {
			--		RaidMembers = {
			--			type = 'description',
			--			order = 1,
			--			name = L['Current Raid Members'],
			--		},
			--	},
			--},
			GeneralOptions = {
				type = 'group',
				name = L['General Options'],
				order = 10,
				args = {
					GeneralOptionsDesc = {
						type = 'description',
						order = 11,
						name = L['General Options'],
					},					
					updateeor = {
						type = 'execute',
						order = 20,
						name = L['Update EOR Points'],
						desc = L['Update point totals at the end of a raid.'],
						func = function() SRT:ConfirmUpdateEndOfRaidPoints() end,
					},
					TrackingOptionsDesc = {
						type = 'description',
						order = 40,
						name = L['Tracking Options'],
					},
					DisplayOnly = {
						type = 'toggle',
						order = 50,
						name = L['Display Points Only'],
						desc = L['Display Points Only Desc'],
						get = function (info) return self.db.global.displayOnly end,
						set = function (info, value) self.db.global.displayOnly = value end,						
					},
					EnableMod = {
						type = 'toggle',
						order = 60,
						name = L['Enable Raid Tracking'],
						desc = L['Check this box to enable raid tracking'],
						get = function(info) return self.db.global.trackRaid end,
						set = function(info, value) self.db.global.trackRaid = value end,
					},
					DebugOptionsDesc = {
						type = 'description',
						order = 70,
						name = L['Debug Options'],
					},
					resetall = {
						type = 'execute',
						order = 80,
						name = L['Reset All Data'],
						desc = L['Reset All Data Desc'],
						func =	function()
									SRT:ResetAll()
								end,
						confirm = true,												
					},
					addguild = {
						type = 'execute',
						order = 90,
						name = L['Add Guild Members'],
						desc = L['Adds online guild members to points list'],
						func =	function()
									SRT:AddGuildMembers()
								end,								
					},
					printraid = {
						type = 'execute',
						order = 100,
						name = L['Print Raid Members'],
						desc = L['Print Raid Members Desc'],
						func =	function()
									SRT:DisplayCurRaidMembers()
								end,
					},
					syncpoints = {
						type = 'execute',
						order = 110,
						name = L['Send Sync Data'],
						desc = L['Send Sync Data Desc'],
						func =	function()
									SRT:SendPointsSyncData()
								end,
					},
				},
			},
			PointCounts = {
				type = 'group',
				name = L['Point Counts'],
				desc = L['Point Counts Desc'],
				order = 20,
				args = {
				},
			},
			DeletePlayers = {
				type = 'group',
				name = L['Delete Players'],
				desc = L['Delete Players'],
				order = 30,
				args = {
				},
			},
			Export = {
				type = 'group',
				name = L['Export'],
				desc = L['Export Desc'],
				order = 40,
				args = {
					exportdesc = {
						order = 10,
						type = 'description',						
						name = L['Export Instructions'],
					},
					PreEoRBBCode = {
						type = 'group',
						name = L['Pre EoR BBCode Export'],
						desc = L['Pre EoR BBCode Export Desc'],
						order = 20,
						args = {					
							exportbbcode = {
								type = 'input',
								order = 20,
								name = L['Export to BBCode'],
								desc = L['BBCode_Export_Desc'],
								get = function()
											return SRT:ExportPointsData('bbcode', true)
										end,
								set = function()
										end,
								multiline = true,						
							},
						},
					},
					PreEoRHTML = {
						type = 'group',
						name = L['Pre EoR HTML Export'],
						desc = L['Pre EoR HTML Export Desc'],
						order = 30,
						args = {					
							exporthtml = {
								type = 'input',
								order = 30,
								name = L['Export to HTML'],
								desc = L['Export to HTML Desc'],
								get = function()
											return SRT:ExportPointsData('html', true)
										end,
								set = function()
										end,
								multiline = true,						
							},
						},
					},
					CurrentBBCode = {
						type = 'group',
						name = L['Current BBCode Export'],
						desc = L['Current BBCode Export Desc'],
						order = 40,
						args = {							
							exportbbcodecurrent = {
								type = 'input',
								order = 50,
								name = L['Export Current to BBCode'],
								desc = L['Export Current to BBCode Desc'],
								get = function()
											return SRT:ExportPointsData('bbcode')
										end,
								set = function()
										end,
								multiline = true,						
							},
						},
					},
					CurrentHTML = {
						type = 'group',
						name = L['Current HTML Export'],
						desc = L['Current HTML Export Desc'],
						order = 50,
						args = {
							exporthtmlcurrent = {
								type = 'input',
								order = 60,
								name = L['Export Current to HTML'],
								desc = L['Export Current to HTML Desc'],
								get = function()
											return SRT:ExportPointsData('html')
										end,
								set = function()
										end,
								multiline = true,						
							},
						},
					},
				},
			},
			IgnoreItems = {
				type = 'group',
				name = L['IgnoredItems'],
				desc = L['IgnoredItemsDesc'],
				order = 40,
				args = {
					IgnoredHeader = {
						type = 'header',
						name = L['IgnoredItems'],
						order = 10,
					},
					IgnoreDesc = {
						type = 'description',
						name = L['AddIgnoreDesc'],
						order = 20,
					},
					AddIgnoredItem = {
						type = 'input',
						name = L['AddIgnoredItem'],
						desc = L['AddIgnoredItemDesc'],
						get = function() return '' end,
						set = function(info, value) SRT:AddToIgnoredItemsList(value) end,						
						order = 30,
					},
					ItemsList = {
						type = 'multiselect',
						name = L['IgnoredItems'],						
						values =	function(info) 
										listData = {}
										for i,v in ipairs(self.db.global.ignoreditems) do
											local sName, sLink, iQuality, iLevel, iMinLevel, sType, sSubType, iCount, sEquipLoc, sTexture = GetItemInfo(v)
											listData[v] = sLink
										end
										return listData;
									end,
						get = function(info, index)
									if not deleteIgnoredItems[index] then
										return false
									else
										return deleteIgnoredItems[index]
									end														
								end,
						set = function(info, index, state)
								deleteIgnoredItems[index] = state;
								end,
						order = 40,						
					},
					DeleteButton = {
						type = 'execute',
						name = 'Delete Selected Items',
						desc = 'This will delete the selected items from the Ignored Items list',
						func = function() 
								end,
						order = 50,
					},
				},
			},			
		},			
	}
	
	if self.db.global.players then
		for i, v in ipairs(self.db.global.players) do
			if v.player and v.points then			
				--table.insert(options.args.PointCounts.args, v.player = {},
				options.args.PointCounts.args[v.player] = {	type = 'input',
																name = v.player,
																desc = '',
																get = function(info)
																			local points = SRT:GetPoints(info[#info])																		
																			return tostring(points)
																		end,
																set =	function(info, value) 																			
																			SRT:ManualSetPoints(info[#info], tonumber(value)) 
																		end, 
															}
				options.args.DeletePlayers.args[v.player] = { type = 'execute', name = v.player, desc = string.format(L['Deletes all data for player %s'], v.player),
																func =	function(info)
																			SRT:DeletePlayerData(info[#info])
																			SRT:CreateConfigMenu()
																		end,
																confirm = true,
															}
			end
		end
	end
	
	--local orderCount = 2	
	--for i,v in ipairs(self.db.global.raidMembers) do
	--	if v then 
	--		local data = SRT:GetPlayerData(v)
	--		options.args.CurrentStats.args[v] = { type = 'description', order = orderCount, name = string.format(L['%s | Rank: %s | Points: %d'], v, data.guildRank, data.points), }
	--		orderCount = orderCount + 1
	--	end
	--end
	--options.args.CurrentStats.args['Spacer1'] = { type = 'description', order = orderCount, name = '', }
	--orderCount = orderCount + 1
	--options.args.CurrentStats.args['ShardCount'] = { type = 'description', order = orderCount, name = string.format(L['Shard Count: %d'], self.db.global.shardCount), }
	--orderCount = orderCount + 1
	--options.args.CurrentStats.args['OffsetCount'] = { type = 'description', order = orderCount, name = string.format(L['Off Spec Count: %d'], self.db.global.offsetCount), }
	--orderCount = orderCount + 1
	--options.args.CurrentStats.args['LootCount'] = { type = 'description', order = orderCount, name = string.format(L['Upgrade Count: %d'], self.db.global.lootCount), }
	--orderCount = orderCount + 1
	
	options.args.profile = AceDBOptions:GetOptionsTable(self.db)
	
	AceConfig:RegisterOptionsTable('SRTConfig', options, {'srt', 'srtconfig'})	
	
	if SRTAddedToBlizzConfig == false then
		AceConfigDialog:AddToBlizOptions('SRTConfig', L['Seraphim Raid Tracker'])	
		SRTAddedToBlizzConfig = true
	end

end


